﻿XIncludeFile "Includes\Portierung.pb"
XIncludeFile "Includes\Brett.pb"
XIncludeFile "Includes\Generator.pb"
XIncludeFile "Includes\KI.pb"
XIncludeFile "Includes\TextGrafik.pb"
XIncludeFile "Includes\SpielAblauf.pb"

UseModule Portierung
UseModule BrettStruktur
UseModule Brett  
UseModule Generator
UseModule KI
UseModule TextGrafikOutput
UseModule SpielAblauf

Define Spiel.Muehlespiel

If ReadFile(0, "MaximalStellung.brt" ) 
  Spiel\Quelle\HalbZug    =Val( ReadString(0) )
  Spiel\Quelle\BF_Brett(0)=Val( ReadString(0) )
  Spiel\Quelle\BF_Brett(1)=Val( ReadString(0) )              
  CloseFile(0)
EndIf


Define AnzBits.i=64
Define v.l
Debug RSet(Bin(Spiel\Quelle\BF_Brett(0)), AnzBits, "0")            + "  weiss"
Debug RSet(Bin(Spiel\Quelle\BF_Brett(1)), AnzBits, "0")            + "  schwarz" 
Debug RSet(Bin(PositionenBesetzt(Spiel\Quelle)), AnzBits, "0")     + "  besetzt" 
Debug RSet(Bin(PositionenFrei(Spiel\Quelle)), AnzBits, "0")        + "  frei"
Debug RSet(Bin(NachbarFrei(Spiel\Quelle,2) ), AnzBits, "0")        + "  nachbar frei"
Debug RSet(Bin(SteineBeweglich(Spiel\Quelle,1) ), AnzBits, "0")    + "  steine beweglich"
Debug RSet(Bin(SteineGeschuetzt(Spiel\Quelle,1) ), AnzBits, "0")   + "  steine geschuetzt"
Debug RSet(Bin(SteineUngeschuetzt(Spiel\Quelle,1) ), AnzBits, "0")   + "  steine ungeschuetzt"
Debug RSet(Bin(BitSet(%01000000000000000000000000000000,31) ), AnzBits, "0")                      + "  BitSet"
Debug RSet(Bin(BitReset(%11000000000000000000000000000000,30) ), AnzBits, "0")                    + "  BitReset"
v=1
Debug RSet(Bin(~v & $FFFFFF), AnzBits, "0") + "  Bitnegation von v.l auf 24 Bit begrenzt"

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 38
; FirstLine = 9
; EnableXP