﻿XIncludeFile "Includes\Portierung.pb"
XIncludeFile "Includes\Brett.pb"
XIncludeFile "Includes\Generator.pb"
XIncludeFile "Includes\KI.pb"
XIncludeFile "Includes\TextGrafik.pb"
XIncludeFile "Includes\SpielAblauf.pb"

UseModule Portierung
UseModule BrettStruktur
UseModule Brett  
UseModule Generator
UseModule KI
UseModule TextGrafikOutput
UseModule SpielAblauf

Define imgID.i, Event.i, mx.i, my.i;GUI, Mausposition bei Klick
Define Spiel.Muehlespiel, dx.i,dy.i,BrettKlick,ZuSetzendeFarbe;Spiel, angeklickte Brettposition
Define i.i, k.i
Dim QAusgabe.s(6)

Spiel\SpielStatus=0
Spiel\Quelle\Halbzug=0

LoadFont(1,"Lucida Console", 10);zwingend notwendiger Monospaced Font fürs EditorGadget
   
If OpenWindow(0, 0, 0, 800, 600, "Mühle", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 1, 1, 400, 400)
  OptionGadget(1, 10, 410, 100, 20, "Mensch vs. KI")
  OptionGadget(2, 10, 435, 100, 20, "KI vs. Mensch")
  SetGadgetState(1, 1)  
  TextGadget(3, 10, 470, 190, 20, "KI Tiefe:")
  StringGadget(4, 100, 470, 40, 20, "4", #PB_String_Numeric)
  ComboBoxGadget(5, 10, 505, 180, 25)
  AddGadgetItem(5, -1, "MiniMax")
  AddGadgetItem(5, -1, "MiniMax Split")
  AddGadgetItem(5, -1, "AlphaBeta")
  AddGadgetItem(5, -1, "AlphaBeta Split")
  SetGadgetState(5, 2)
  ButtonGadget(6, 10, 550, 220, 35, "Starte Spiel")
  EditorGadget(7, 410, 10, 380, 580,#PB_Editor_ReadOnly)
  SetGadgetFont(7, FontID(1))
    
  ZeichneBrett (0,@Spiel\Quelle)
  
  Repeat
    Event = WaitWindowEvent()
    BrettKlick=-1
    
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
          Case 0
            ;Mausposition bei Klick in Canvas         
            If EventType() = #PB_EventType_LeftClick
              mx = GetGadgetAttribute(0, #PB_Canvas_MouseX)
              my = GetGadgetAttribute(0, #PB_Canvas_MouseY)
              
              ;Prüfen ob der Mausklick "über" einer Brettposition gemacht wurde              

              For i =0 To 23
                dx=Board(i)\x - mx
                dy=Board(i)\y - my
                If (dx*dx + dy*dy) <= 30*30;sensibler anklickbarer Kreis um Brettposition. Quadrat des Radius reicht, Sqr brauchen wir nicht
                  BrettKlick=i
                EndIf
              Next i                
            EndIf
          
          Case 6
            If Spiel\SpielStatus=0;Starte das Spiel entsprechend den Optionen in der GUI
              ;                  1 wenn KI starten soll   KI Tiefe aus Gadget 4   KI Suchbaum Algo aus Gadget5
              SpielStart(@Spiel, GetGadgetState(2),       Val(GetGadgetText(4)),       (GetGadgetState(5) + 1) ) 
              ;GUI aktualisieren
              For i=1 To 5
                DisableGadget(i, 1)
              Next i
              SetGadgetText(6, "Stoppe Spiel")
           
            Else ;Abbruch           
              Spiel\SpielStatus=0
              ;GUI aktualisieren              
              For i=1 To 5
                DisableGadget(i, 0)
              Next i              
              SetGadgetText(6, "Starte Spiel")

            EndIf
        EndSelect         
    EndSelect
    
    If Spiel\SpielStatus
      Select Spiel\SpielStatus
        Case 1
          ZugVorbereitungMensch (@Spiel)
        
        Case 2
          If BrettKlick>-1
            SteinWaehlen (@Spiel, BrettKlick)
          EndIf
        
        Case 3
          If BrettKlick>-1
            SteinSetzen (@Spiel, BrettKlick)
          EndIf
          
        Case 4
          If BrettKlick>-1
            Entfernen (@Spiel, BrettKlick)
          EndIf
        
        Case 5
          If BrettKlick>-1
            EntfernenZwei (@Spiel, BrettKlick)
          EndIf
          
        Case 6
          ZugBeendenMensch (@Spiel)         
          AddGadgetItem(7, -1, " Halbzug: " + Str(Spiel\Quelle\Halbzug) + ":")
          BrettZuText(@Spiel\Quelle, QAusgabe() )
          For k=0 To 6
            AddGadgetItem(7, -1, QAusgabe(k))
          Next k           
          AddGadgetItem(7, -1, "")
           
        Case 7
          ZugKI (@Spiel)
          AddGadgetItem(7, -1, " Halbzug: " + Str(Spiel\Quelle\Halbzug) + ":")
          BrettZuText(@Spiel\Quelle, QAusgabe() )
          For k=0 To 6
            AddGadgetItem(7, -1, QAusgabe(k))
          Next k
          AddGadgetItem(7, -1, "") 
                   
      EndSelect
    EndIf
        
  Until Event = #PB_Event_CloseWindow   
EndIf

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 126
; EnableXP
; Executable = ZugGenerator.exe