﻿XIncludeFile "Includes\Portierung.pb"
XIncludeFile "Includes\Brett.pb"
XIncludeFile "Includes\Generator.pb"
XIncludeFile "Includes\KI.pb"
XIncludeFile "Includes\TextGrafik.pb"
XIncludeFile "Includes\SpielAblauf.pb"

UseModule Portierung
UseModule BrettStruktur
UseModule Brett  
UseModule Generator
UseModule KI
UseModule TextGrafikOutput
UseModule SpielAblauf

Define imgID.i, Event.i, mx.i, my.i;GUI, Mausposition bei Klick
Define Spiel.Muehlespiel, dx.i,dy.i,BrettKlick,ZuSetzendeFarbe;Spiel, angeklickte Brettposition
Define zeile.s, i.i, k.i, counter.i;für FileLoader,ForNext
Dim QAusgabe.s(6)
Dim ZAusgabe.s(6)

ZuSetzendeFarbe=0;0=weiss,1=schwarz,2=löschen
Spiel\Quelle\Halbzug=0

LoadFont(1,"Lucida Console", 10);zwingend notwendiger Monospaced Font fürs EditorGadget
   
If OpenWindow(0, 0, 0, 800, 600, "ZugGenerator Tester", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(0, 1, 1, 400, 400)
  OptionGadget(1, 10, 445, 80, 25, "weiss")
  OptionGadget(2, 10, 480, 80, 25, "schwarz")
  OptionGadget(3, 90, 463, 80, 25, "löschen")
  SetGadgetState(1, 1)  
  ButtonGadget(4, 10, 530, 100, 25, "laden")
  ButtonGadget(5, 10, 565, 100, 25, "sichern")
  ComboBoxGadget(6, 210, 445, 180, 25)
  AddGadgetItem(6, -1, "weiss")
  AddGadgetItem(6, -1, "schwarz")
  SetGadgetState(6, 0)
  ComboBoxGadget(7, 210, 480, 180, 25)
  AddGadgetItem(7, -1, "setzen")
  AddGadgetItem(7, -1, "schieben/springen")
  SetGadgetState(7, 0)
  ButtonGadget(8, 210, 530, 180, 60, "Berechne Züge")  
  EditorGadget(9, 410, 10, 380, 580,#PB_Editor_ReadOnly)
  SetGadgetFont(9, FontID(1))
  
  ZeichneBrett (0,@Spiel\Quelle)

  Repeat
    Event = WaitWindowEvent()
    
    Select Event
   
      Case #PB_Event_Gadget
        Select EventGadget()
          
          Case 0
            ;Mausposition bei Klick in Canvas         
            If EventType() = #PB_EventType_LeftClick
              mx = GetGadgetAttribute(0, #PB_Canvas_MouseX)
              my = GetGadgetAttribute(0, #PB_Canvas_MouseY)
              
              ;Prüfen ob der Mausklick "über" einer Brettposition gemacht wurde              
              BrettKlick=-1
              For i =0 To 23
                dx=Board(i)\x - mx
                dy=Board(i)\y - my
                If (dx*dx + dy*dy) <= 30*30;sensibler anklickbarer Kreis um Brettposition. Quadrat des Radius reicht, Sqr brauchen wir nicht
                  BrettKlick=i
                EndIf
              Next i
              ;falls eine Position erfolgreich angeklickt wurde...              
              If BrettKlick>-1
                ;MessageRequester("", "Position " + BrettKlick, #PB_MessageRequester_Ok)
                SetzeFarbe(@Spiel,BrettKlick,ZuSetzendeFarbe)  
                ZeichneBrett (0,@Spiel\Quelle)                          
              EndIf             
            EndIf
          
          Case 1
            ZuSetzendeFarbe=0;weiss
            
          Case 2
            ZuSetzendeFarbe=1;schwarz
          
          Case 3
            ZuSetzendeFarbe=2;löschen  
          
          Case 4
            If ReadFile(0, OpenFileRequester("Laden...", GetCurrentDirectory(), "*.brt",0) ) 
              Spiel\Quelle\HalbZug    =Val( ReadString(0) )
              Spiel\Quelle\BF_Brett(0)=Val( ReadString(0) )
              Spiel\Quelle\BF_Brett(1)=Val( ReadString(0) )
              ZeichneBrett (0, @Spiel\Quelle)        
              CloseFile(0)
              ;GUI an geladenes Brett anpassen
              Select  Spiel\Quelle\HalbZug
                Case 0
                  SetGadgetState(6, 0)
                  SetGadgetState(7, 0)
                  
                Case 1
                  SetGadgetState(6, 1)
                  SetGadgetState(7, 0)                
                
                Case 18
                  SetGadgetState(6, 0)
                  SetGadgetState(7, 1)                
                
                Case 19
                  SetGadgetState(6, 1)
                  SetGadgetState(7, 1)                
                
              EndSelect
            EndIf
                     
          Case 5
            If CreateFile(0, SaveFileRequester("Sichern...", GetCurrentDirectory(), "*.brt",0))        
              WriteStringN(0, Str(Spiel\Quelle\HalbZug) ) 
              WriteStringN(0, Str(Spiel\Quelle\BF_Brett(0)) )
              WriteStringN(0, Str(Spiel\Quelle\BF_Brett(1)) )
              
              BrettZuText(Spiel\Quelle, QAusgabe() )
              For k=0 To 6
                WriteStringN(0, QAusgabe(k))
              Next k
              CloseFile(0)                      
            EndIf
          
          Case 6, 7
          ;nichts  
                     
          
          Case 8
            ;                      (0 oder 1)      +   (0 oder 18)        ->  0,1,18,19 <- Halbzugnummer der Ausgangsstellung
            Spiel\Quelle\Halbzug =GetGadgetState(6) + GetGadgetState(7)*18 
            Spiel\MenschAnzahlStellungen=HalbzugGenerator (@Spiel\Quelle, Spiel\MenschStellungen())          
            ;wenn Zeilen im Editor vorhanden, alle löschen
            counter=CountGadgetItems(9)
            If counter
              For i=counter-1 To 0 Step -1
                RemoveGadgetItem(9,i)  
              Next i 
            EndIf
            AddGadgetItem(9, -1, " gefundene Züge: " + Str(Spiel\MenschAnzahlStellungen))
            AddGadgetItem(9, -1, " Halbzug: " + Str(Spiel\Quelle\Halbzug + 1))
            BrettZuText(Spiel\Quelle, QAusgabe() )
            For i=0 To Spiel\MenschAnzahlStellungen-1
              AddGadgetItem(9, -1, Str(i+1)+ ":")
              BrettZuText(Spiel\MenschStellungen(i), ZAusgabe() )
              For k=0 To 6
                AddGadgetItem(9, -1, QAusgabe(k) + "  >>  " + ZAusgabe(k))
              Next k
              AddGadgetItem(9, -1, "")    
            Next i        
       EndSelect
    EndSelect
  Until Event = #PB_Event_CloseWindow   
EndIf

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 18
; FirstLine = 12
; EnableXP
; Executable = ZugGenerator.exe
; DisableDebugger